from defs import *
from consts import *

def is_perfect_classification(network, X, sess):
	return network.check_predriction_for_dataset(sess) == X.shape[0]

def find_max_norm_inf(network):
	return np.max([calc_norm_inf(network, i) for i in range(network.r)])

def calc_norm_inf(network, i):
	return np.max(network.W[i])

def find_indexes_above_half_of_max(network, prune_factor_weight, prune_factor_total_norm):
	max_norm_inf = find_max_norm_inf(network)
	indexes = [i for i in range(network.r) if prune_factor_weight * calc_norm_inf(network, i) > prune_factor_total_norm * max_norm_inf]
	return indexes

def reconstruction(network, i, reconstruction_factor_weight, reconstruction_factor_norm):
	reconstruction_nueron = np.zeros([D], dtype=TYPE)
	info_norm = calc_norm_inf(network, i)
	for j in range(D):
		if reconstruction_factor_weight * np.abs(network.W[i][j]) >= reconstruction_factor_norm * info_norm:
			if network.W[i][j] > 0:
				reconstruction_nueron[j] = 1
			else:
				reconstruction_nueron[j] = 1
	return reconstruction_nueron

def check_reconstruction(network, readonce, noize_size, reconstruction_factor_weight, reconstruction_factor_norm):
	terms_flag = [False] * len(readonce.DNF)
	for i in range(network.r):
		reconstruction_nueron = reconstruction(network, i, reconstruction_factor_weight, reconstruction_factor_norm)
		flag = False
		for j, term in enumerate(readonce.DNF):
			term = np.pad(term, [0, noize_size], 'constant', constant_values=(0))
			if np.array_equal(term, reconstruction_nueron):
				flag = True
				terms_flag[j] = True
		if not flag:
			return False
	if False in terms_flag:
		return False
	return True
